from django.shortcuts import render
from django.http import HttpResponse
from django.contrib.auth import authenticate
from django.contrib.auth.decorators import login_required
from django.contrib.auth.models import User
from allocation.models import *
#from allocation.forms import PreferenceForm
from django.forms import modelform_factory
from django.forms import modelformset_factory
from django.views import generic
from django.views.generic.edit import CreateView

# @login_required(login_url='/admin/login')
# def index(request): #for /allocation
# 	applicant=Applicant.objects.filter(name=request.user.username)[0]
# 	# form = PreferenceForm(
# 	# 	initial={'name': applicant.name , 'rank': applicant.rank}
# 	# 	)
# 	form = ArticleForm(instance=applicant)
# 	return render(request, 'allocation/index.html', {'applicant': applicant, 'form': form})


AppFormset = modelformset_factory(Application,fields=("choice", "priority" ), extra=5)

@login_required(login_url='/admin/login')
def index(request): #for /allocation
	applicant=Applicant.objects.filter(name=request.user.username)[0]
	# form1 = modelform_factory(Applicant, fields=("name", "rank" ))
	formset = AppFormset(queryset=Application.objects.filter(applicant=applicant),)
	return render(request, 'allocation/index.html', {'applicant': applicant,  'formset': formset,})


# def submit(request):
# 	if request.method == 'POST':
# 		formset = AppFormset(request.POST)
# 		if formset.is_valid():
# 			for form in formset:
# 				if form.is_valid():
# 					cd = f.cleaned_data
# 					application.applicant=cd.get('applicant')
# 					application.choice=cd.get('choice')
# 					application.priority=cd.get('priority')
# 					application.save()
# 		else:
# 			return HttpResponse('error')


def submit(request):
	if request.method == 'POST':
		formset = AppFormset(request.POST)
		instances = formset.save()
		return HttpResponse("successful")

@login_required(login_url='/admin/login')
def admin1(request):
	institute=Institute.objects.filter(name=request.user.username)[0]
	return render(request, 'allocation/admin1.html',{'institute': institute})


class ChoiceListView(generic.ListView):
	model = Choice
	def get_context_data(self, **kwargs):
		institute=Institute.objects.filter(name=self.request.user.username)[0]
		context = super(ChoiceListView, self).get_context_data(**kwargs)
		context['institute'] = institute
		return context
	def get_queryset(self):
		institute=Institute.objects.filter(name=self.request.user.username)[0]
		return Choice.objects.filter(institute__name=institute.name)

class ApplicantListView(generic.ListView):
	model = Applicant
	def get_context_data(self, **kwargs):
		institute=Institute.objects.filter(name=self.request.user.username)[0]
		context = super(ApplicantListView, self).get_context_data(**kwargs)
		context['institute'] = institute
		return context
	def get_queryset(self):
		institute=Institute.objects.filter(name=self.request.user.username)[0]
		return Applicant.objects.filter(institute__name=institute.name)

class ChoiceDetailView(generic.DetailView):
	model = Choice
	def get_context_data(self, **kwargs):
		institute=Institute.objects.filter(name=self.request.user.username)[0]
		context = super(ChoiceDetailView, self).get_context_data(**kwargs)
		context['institute'] = institute
		return context

class ApplicantDetailView(generic.DetailView):
	model = Applicant
	def get_context_data(self, **kwargs):
		institute=Institute.objects.filter(name=self.request.user.username)[0]
		context = super(ApplicantDetailView, self).get_context_data(**kwargs)
		context['institute'] = institute
		return context

class ChoiceCreateView(CreateView):
    model = Choice
    fields = ['choice_name', 'capacity', 'institute']







